!
! Not what everyone should do, but it is what I shall do
!
! I am going to read in the CD144 data created by CDO2CD144
! all hours sequentually, saving the image of the CD144 in one array
! and saving the wind speed in knots in a second array.
!
! Once this is complete, I will search for a 0 wind spd, and will use
! nonzero values to interpolate and fill in a nonzero wind spd.
!
! The assumption is we only process at most 1-yeare of data
!
      character*80 card(8784), image
      character*40 filename
      character*2  adir,aspeed
      character*1  cdout(80)
      integer      wdir(8784),spd(8784)
      
      open(30,file='FilledCD144.txt')
      
10    write(*,*) ' CD144 file to be processed: '
      read(*,*) filename
      open(20,file=filename,status='old',err=10)
      
      icount = 1
20    continue
      read(20,1000,end=30) card(icount)
1000  format(a80)      
      read(card(icount),1010) idir,ispeed
1010  format(t39,2i2)
      wdir(icount) = idir
      spd(icount)  = ispeed      
      icount = Icount + 1
      go to 20
      
30    continue
      num = icount-1
      
      i = 0
40    continue
      i = i + 1
      
         if(i.gt.num) go to 500
         
      !search for a zero wind speed
      if(spd(i).gt.0 ) go to 40
         !go forward and look for the next nonzero spd
         igood = i-1
         j = i
50       continue
         j = j+1
         
            if(j.gt.num) then
            !end of record, have to fill this in by hand
              do k=i,j
              spd(k) = -9
              end do
              go to 500
            end if
            
         if( spd(j).eq.0 ) go to 50
         !we have found the next nozero spd
         ngood = j
         
         speed1 = float( spd(igood) )
         speed2 = float( spd(ngood) )
         ihours = ngood-igood
         dspd = (speed2-speed1)/float(ihours)
            if( ihours.eq.2 ) then
               speed = speed1 + dspd
               spd(igood+1)  = NINT(speed)
               wdir(igood+1) = 27
               go to 60
            end if
            
            !we have more than one hour to fill
            do k=1,ihours
               speed = speed1 + k*dspd
               spd(igood+k)  = NINT(speed)
               wdir(igood+k) = 27
            end do
            
60          continue
            i = ngood
            go to 40
            
            
500   continue
      !we now fill in all spd values as we list out the cd144 values
      do i=1,num
         image = card(i)
         ispeed = spd(i)
         idir   = wdir(i)
         write(adir,2000)   idir
         write(aspeed,2000) ispeed
2000     format(i2.2)
         do j=1,80
         cdout(j:j) = image(j:j)
         end do
         cdout(39:39) = adir(1:1)
         cdout(40:40) = adir(2:2)
         cdout(41:41) = aspeed(1:1)
         cdout(42:42) = aspeed(2:2)
         write(30,3000) (cdout(k:k),k=1,80)
3000     format(80a1)         
      end do  
      
      stop
      end
      
      
            
      