
!
!  Wrote this program to generate a set of polar receptors
!  and list them out (with a zero terrain height and a user-defined receptor height)
!  that is compatible with ISCST3 receptor formats.
!

      dimension dist(12)
      
      convert = 3.14159/180.0
      rhgt = 1.5
      open(20,file='receptors.txt')
      
      write(*,*) ' How many rings: '
      read(*,*) Narcs
      
      write(*,*) 'Enter ring distances: '
      read(*,*) (dist(i),i=1,Narcs)
      
      write(*,*) ' Number of Receptors on a ring: '
      read(*,*) Nrecp
  
      write(*,*) 'Starting Azimuth (deg) and spacing (deg): '
      read(*,*) StartAz, Spacing
      
      ! I will assume that the origin is (0,0)
      WRITE(20,*) '     Narcs: ',Narcs
      write(20,*) ' Distances: ',(dist(i),i=1,Narcs)
      write(20,*) '     Nrecp: ',Nrecp
      
      do iarcs=1,Narcs
         
         do irecpt=1,Nrecp
         ! compute x,y coordinate for this receptor
         ! the assumption is all receptors are east of source
         Az = StartAz + (irecpt-1)*Spacing
         
         angle = 90.0 - Az
         radangle = convert*angle
         x = dist(iarcs)*cos(radangle)
         y = dist(iarcs)*sin(radangle)
         
         write(20,1000) x,y,rhgt
1000     format('RE DISCCART    ',3(f10.3,2x))
         
         end do
      
      end do
      
      stop 
      end
      