
      PARAMETER (NMAX=200)

      CHARACTER*10 DATE,TIME
      character*10 OldDate,NewDate
      character*10 OldTime,NewTime

      COMMON/MAIN0/ XDIST,CONV,Q
      COMMON/MAIN1/ SCALE,XC,YC
      COMMON/MAINN/ ITEST,ITRAV,DATE,TIME
   
      COMMON/MET/ OBK,TS,VS

      DIMENSION PHI(NMAX),AX(NMAX),AY(NMAX),AC(NMAX)
      DIMENSION C(NMAX),Y(NMAX),X(NMAX)
      DIMENSION WC(NMAX),WY(NMAX),WX(NMAX)
      DIMENSION WWY(NMAX)
      DIMENSION YDSY(NMAX)
      
      dimension arcs(12)
      integer   judgement(2,12,31,0:23,13)
      
      data arcs/0.5,1.0,2.0,3.0,5.0,7.0,10.0,15.0,20.0,30.0,40.0,50.0/
      data OldDate/'9999999999'/
      data iTest /0/
 
      SCALE = 1000.0      !conversion km to meters
      XC = 285.597        !coordinates of release
      yc = 4385.088
      
      iyrlast = 0
      imnlast = 0
      idylast = 0
      ihrlast = 0
      
      call FetchQC(judgement)     !Fetch QC codes for Kincaid Arcs
      
      open(55,file='KincaidOBSAnalysis.txt')
      !
      !     add definition of output variables to output file
      write(55,1050)
1050  format(20x,'  DUR     Dist         Arc           Q    Hanna-Paine-OBK     &
      &  OMAX           CMAX           CY            CMAX/Q          CY/Q            Sy         PHIC',/,&
      &4x,' Exp  YYMMDDHHMM (min)    (km)         (km)        (g/s)         (m)    ',&
      &'   (gx10^-6/m^3)  (gx10^-6/m^3)  (sx10^-6/m^2)  (sx10^-6/m^3)  (sx10^-6/m^2)        (m)      (degrees)')
     
      !As we process the observations, we will construct the hourly emission
      !file needed by ISCST3 and AERMOD (they both use the same format)
      open(60,file='KINemissions.txt')

      !Open the file containing the SF6 concentration along each arc
      open(10,file='KincaidSF611052011.txt',status='old')

500   continue

      !read first the header, to see if this is the end of the input file
      !if not we call Fetch
        
      read(10,2000,end=900) NewDate,NewTime
2000  format(t32,a10,t78,a10)

      if( NewDate.eq.'          ') go to 900
      
      !Assign Experiment numbers as we process the data
      !Whenever we see a new date, I increment the counter on IExp
      if( NewDate.ne.OldDate .or. NewTime.ne.OldTime ) then
      iTest    = iTest + 1
      OldDate = NewDate
      OldTime = NewTime
      end if
      Date = NewDate
      Time = NewTime
      
      CALL FETCH(N,YFIRST,NFIRST,NLAST,X,Y,C)
 
        OMAX = 0.0
        NumGTzero = 0
        
!       SWAP USER SELECTED VALUES INTO WORKING ARRAYS
!       AND SEARCH AND DEFINE ARCWISE MAX CONCENTRATION.
        NUM = NLAST - NFIRST + 1
        DO I = NFIRST, NLAST
        II     = (I-NFIRST) + 1
        WX(II) = X(I)
        WY(II) = Y(I)
        WC(II) = C(I)
        if( wc(ii).gt.0.0 ) NumGTzero = NumGTzero + 1
        IF( WC(II).GT.OMAX) OMAX = WC(II)
        end do      
 
      read(date,2005) iyear,imonth,iday
2005  format(1x,i2,1x,i2,1x,i2)
      read(time,2010) ihour,imin    !beginning hour
2010  format(2i2)
      
      iyr = iyear - 79
      ivalue = judgement(iyr,imonth,iday,ihour,itrav)
      if( ivalue.lt.3 ) go to 500
      
      
      CALL BSTFIT(NUM,OMAX,WC,WX,WY,WWY,PHI,CMAX,SIGY,CDY,RBAR,&
                     &NOK,PHIC,IERR)
      !PHIC is the bearing from the source locations to the center of mass along
      !the arc. Make sure the value is less than 360 degrees.
30    continue
      If( PHIC.gt.360.0 ) then
      PHIC = PHIC - 360.0
      go to 30
      end if

      idur = 60
      
      !We do some checking here for missing met and emissions
      if( Q.lt.0.0 ) then
      CMaxoQ = -99.
      CDYoQ  = -99.
      else
      CMaxoQ = CMAX/Q
      CDYoQ  = CDY/Q
      end if
      
      write(55,1020) itest,iyear,imonth,iday,ihour,imin,idur,Rbar,arcs(itrav),Q,OBK,&
                     &OMAX,CMAX,CDY,CMAXoQ,CDYoQ,SIGY,PHIC
1020  format(3x,i5,2x,5i2.2,2x,i2,4(f10.2,3x),5(3x,1pe12.4),2x,0pf12.3,f12.2)    
 
      
      if( iyear.ne.iyrlast .or. imnlast.ne.imonth .or. idylast.ne.iday .or. ihrlast.ne.ihour ) then
      ihrout = ihour
      Qout = 1000.0
      write(60,1030) iyear,imonth,iday,ihrout,Qout,TS,VS
1030  format('SO HOUREMIS',4i3,' STACK ',3F12.3)
      iyrlast = iyear
      imnlast = imonth
      idylast = iday
      ihrlast = ihour
      end if

      go to 500

900   continue      

      STOP
      END
      
      subroutine FetchQC(judgement)
      ! Here we open the master file that has all the judgement QC codes
      ! for KPRI Kincaid; read them end and store them for later use
      integer   judgement(2,12,31,0:23,13)      

      open(50,file='kincaidsf6-max11052011.txt',status='old')
      ! read in and store the judgement codes for each hour of data
      do i=1,48
      !read past headers
      read(50,*)      
      end do
      
10    continue
      read(50,1000,end=20)iyear,imonth,iday,ihour,ArcDist,ivalue
1000  format(t3,i2,1x,i2,1x,i2,t20,i2,t42,f4.1,t88,i1)
      !we will have to convert the ArcDist to a traverse number
      call DefineArc(ArcDist,iarc)
      iyr = iyear-79
      judgement(iyr,imonth,iday,ihour,iarc) = ivalue  
      go to 10
20    continue
      close (50) 
                 
      return
      end
      
      subroutine DefineArc(Dist4real,iarcout)
      ! Hanna and Chang marked suspicious data by setting them arc = 99
      ! I am incorporating them back into the data, but need to know
      ! which arc I have placed them using Dist4real
      
      ! The routine below should perform the task
      
      dimension Arcs(12)
      data      Arcs/0.5,1.0,2.0,3.0,5.0,7.0,10.0,15.0,20.0,30.0,40.0,50.0/

      iarcout = 0
      
      do ia=1,12
      
      if(ia.eq.1) then
      bottom = 0.01
      top    = 1.0 - 0.250001  
      elseif(ia.eq.12) then
      bottom = 50.0 - 5.00
      top    = 80.0
      else
      bottom = arcs(ia) - (arcs(ia)-arcs(ia-1))/2.0 
      top    = arcs(ia) + (arcs(ia+1)-arcs(ia))/2.0 - 0.000001
      end if      
      
            
      if( Dist4real.gt.bottom .and. Dist4real.lt.top ) then
      iarcout = ia
      end if

      end do
           
      return
      end
            
 
!***********************************************************************
      subroutine SAvg(num,wrkary,avg)
!     compute average of num values located
!     in array wrkary.

      dimension wrkary(1000)

      sum = 0.0
      if( num.eq.0 .or. num.gt.1000 ) then
         avg = -99.
         return
      end if

      do 10 i=1,num
         sum = sum + wrkary(i)
10    continue

      avg = sum/float(num)
      return
      end

!***********************************************************************
      subroutine SStd(num,wrkary,std)
!     comute standard deviation of num values located
!     in array wrkary.
      dimension wrkary(1000)

      if( num.eq.0 .or. num.gt.1000 ) then
         std = -99.
         return
      end if

      sumv  = 0.0
      sumvv = 0.0
      do 10 i=1,num
         sumv  = sumv  + wrkary(i)
         sumvv = sumvv + wrkary(i)*wrkary(i)
10    continue

      avgv = sumv/float(num)
      varv = sumvv/float(num) - avgv*avgv
      if( varv.le.0 ) then
         std  = 0.0
      else
         std  = sqrt(varv)
      end if

      return
      end
    
      SUBROUTINE FETCH(NumRcpt,YFIRST,NFIRST,NLAST,X,Y,C)
!
      PARAMETER (NMAX=200)
     
      CHARACTER DATE*10,TIME*10
      Character*120 Card
      
      DIMENSION C(NMAX),Y(NMAX),X(NMAX)
       
      COMMON/MAIN0/ XDIST,CONV,Q
      COMMON/MAIN1/ SCALE,XC,YC
      COMMON/MAINN/ ITEST,ITRAV,DATE,TIME
       
      COMMON/MET/ OBK,TS,VS
      
      data iExp/0/    !we will assign experiment numbers as we process
      
      Scale = 1000.0
      Yfirst = 0.0
    
      Read(10,1000) Card     !fetch from Second card the OBK 
1000  format(a120)  

      ! These OBK values were determined by Hanna and Paine during the 
      ! development of HPDM. I will replace these with AERMOD values 
      ! later in the analysis when I merge together the modeling results 
      ! with the observations. 
      read(Card,1005) OBK
1005  format(t30,f9.2) 
    
      Read(10,1000) Card     !Skip third header card   

      read(10,1000) Card     !Fetch from fourth header the Q and the Conv2ugm3
      read(card,1010) TS,VS,Q,Conv2ugm3
1010  format(t30,f8.2,t47,f9.2,t67,f9.2,t87,g11.4)
      
      READ(10,1000) card
      read(card,1020) ArcDist,NumRcpt
1020  format(t12,f5.1,t32,i5)

      Nfirst = 1
      Nlast = NumRcpt

      !we will have to convert the ArcDist to a traverse number
      call DefineArc(ArcDist,itrav)
      
      !read past a header
      read(10,1000) card
 
       DO I = Nfirst,NumRcpt
       
       READ(10,1030) X(I),Y(I),C(I)
1030   format(t5,f8.2,f10.2,t33,f10.2)       
      
       !convert concentrations to micrograms/m^3
       if( C(I).gt.0.0 ) C(I) = Conv2ugm3*C(I)

       end do

      RETURN
      END

      SUBROUTINE BSTFIT(NUM,OMAX,C,X,Y,WY,PHI,CMAX,SY,CDY,RBAR,NOK,PHIC,IERR)

      PARAMETER (NMAX=200)

!     THIS ROUTINE CALCULATES THE BEST-FIT GAUSSIAN PARAMETERS (CMAX,
!     YMAX,AND SIGY) TO TRAVERSE DATA. 
!

      CHARACTER*10 DATE,TIME
      INTEGER   VERSION, FIRST
      COMMON/MAINN/ ITEST,ITRAV,DATE,TIME
      COMMON/MAIN1/ SCALE,XC,YC


      DIMENSION C(NMAX),X(NMAX),Y(NMAX),WY(NMAX)
      DIMENSION PHI(NMAX),R(NMAX),DPHI(NMAX)
      DIMENSION WC(NMAX)
      DIMENSION obs(nmax),pred(nmax),wwy(nmax)

      DATA PI/3.14159/

!     CMAX=CENTER-LINE CONCENTRATION

      IERR = 0
      CALL ARC(NUM,C,X,Y,PHI,DPHI,NOK,CX,CY,PHIC,RBAR,OMAX,IERR)

      IF( IERR.LT.0 ) THEN
      RETURN
      END IF

!     SET UP CALCULATION ARRAY
      NTEMP = 0
      DO 40 I=1,NUM
      WY(I) = (DPHI(I)/360.0)*2.0*PI*SCALE*RBAR
      R(I)  = ABS(WY(I))
      
      IF(C(I).GE.0.0 ) THEN
      NTEMP = NTEMP + 1
      WC(NTEMP) = C(I)
	  wwy(NTEMP)= wy(i)
      END IF
      
40    CONTINUE
      nok = ntemp

!
!     ESTIMATE SY FROM SECOND MOMENT CONSIDERATIONS
      CALL SYSM(NOK,WC,WWY,SY,IERR)
!
!     when key equals zero, then we do not add 'tails' to crosswind
!     integrated concentration.  when using all values you will
!     naturally 'bound' the integral with zero values, hence no need to
!     add 'tails.'

!     trapezoidal area using all reported values
      key = 0
	  call areatp(nok,wc,wwy,cytrp1,key)
!     For now we will use Cytrp1 for estimating Cmax
      cdy = cytrp1
!
!     CALCULATE CMAX GIVEN SYEST AND CDY
      IF( SY.GT.0.0 .AND. CDY.GT.0.0 ) THEN
      CMAX = CDY/( SY*SQRT(2.0*PI) )
      ELSE
      CMAX   = -99.
      IERR   = -2
      END IF

45    CONTINUE

 
      RETURN
      END

      SUBROUTINE ARC(N,C,X,Y,PHI,DPHI,NOK,CX,CY,PHIC,RBAR,OMAX,IERR)

      PARAMETER (NMAX=200)
!
!  1.  Convert X and Y location of receptors into azimuths (phi)
!     in the meteorological sense.  Omax is the largest obs conc. value.

!  2.  Compute the center of mass coordinates (CX,CY), assuming
!     we have at least 3 or more values >= 0.0 to work with.
!     While we do this, compute rbar (average distance to receptors.

!  3.  Convert CX and CY to azimuth in the meteorological sense.

!  4.  Compute the angular separation of the receptor azimuths
!     (dphi = phi-phic), where dphi is restricted to be within
!     -180 and +180 degrees.

!  5.  Sort the dphi values (carrying along x,y,c) from lowest to
!     highest.

!  6.  Compute phi by adding phic to the sorted dphi values.
!     and while we do this, swap in sorted x,y,c values.


      CHARACTER DATE*10,TIME*10

      COMMON/MAIN1/ SCALE,XC,YC
      COMMON/MAINN/ITEST,ITRAV,DATE,TIME

      DIMENSION X(NMAX),Y(NMAX),C(NMAX),PHI(NMAX),DPHI(NMAX)
      DIMENSION AX(NMAX),AY(NMAX),AC(NMAX)
!
      DATA PI/3.14159/
!
!     INITIAL CHECKS
!
      IF(N.GT.NMAX) THEN
      IERR = -4
      WRITE(IUT,*) 'NUM  = : ',N
      WRITE(IUT,*) 'NMAX = : ',NMAX
      GO TO 70
      END IF
!
!     DEFINE CONVERSIONS FROM DEGREES TO RADIANS AND
!     RADIANS TO DEGREES
!
      CONV1 = 180.0/PI
      CONV2 = PI/180.0
!
!
!   STEP ONE:  COMPUTE PHI-ARRAY VALUES AND
!              INITIAL FILL OF AX, AY, AC ARRAYS
!
      Omax = -99999.
      DO 10 I=1,N
!
      AX(I) = X(I)
      AY(I) = Y(I)
      AC(I) = C(I)
      if( c(i).gt.Omax ) Omax = c(i)
!
      DX = AX(I) - XC
      DY = AY(I) - YC
      A = ATAN2(DY,DX)
!
!     CONVERT DEGREES AND PLACE IN METEORLOGICAL SENSE
!
      IF(A.GE.0.0) THEN
      PHI(I) = 450.0 - CONV1*A
      ELSE
      PHI(I) =  90.0 - CONV1*A
      END IF
      IF(PHI(I).GT.360.0) PHI(I) = PHI(I) - 360.0
!
   10 CONTINUE
!
!   STEP TWO:  Compute the center of mass, but make sure it
!              makes sense, ie we have at least 3 nonzero
!              concentrations to work with.
!
!     COMPUTE CENTROID COORDINATES (CX,CY)
      CX   = 0
      CY   = 0
      SUMC = 0
      NOK  = 0
      rsum = 0
      DO 20 I=1,N
      IF(C(I).GT.0.0) THEN
      CX = CX + X(I)*C(I)
      CY = CY + Y(I)*C(I)
      r  = sqrt( (x(i)-xc)*(x(i)-xc) + (y(i)-yc)*(y(i)-yc) )
      rsum = rsum + r
      SUMC = SUMC + C(I)
      NOK = NOK + 1
      END IF
20    CONTINUE

!
!     SEE IF WE HAVE ENOUGH VALUES TO WORK
!     WITH.  NOK MUST BE GE. 3 TO CONTINUE.
!
      IF( NOK.LT.3 ) THEN
      IERR = -2
      return
      END IF

      CX = CX/SUMC
      CY = CY/SUMC
      RBAR = rsum/float(nok)

!
!   STEP THREE: DEFINE PHIC
!
!     FIND PHIC POSITION FOR CENTROID
      CONV1 = 180.0/PI

      DX = CX - XC
      DY = CY - YC
      A  = ATAN2(DY,DX)

!     CONVERT TO DEGREES AND PLACE IN METEORLOGICAL SENSE
!
      IF(A.GE.0.0) THEN
      PHIC = 450.0 - CONV1*A
      ELSE
      PHIC =  90.0 - CONV1*A
      END IF
      IF(PHIC.GT.360.0) PHIC = PHIC - 360.0
!
!
!  STEP FOUR: COMPUTE DPHI VALUES.
!
      do 30 i=1,n
      dphi(i) = phi(i) - phic

      if( dphi(i).gt.180.0 ) then
      dphi(i) = dphi(i) - 360.0
      end if
      if( dphi(i).lt.-180.0 ) then
      dphi(i) = dphi(i) + 360.0
      end if

30    continue
!
!     Now recenter the center of mass in terms of
!     the dphi values.  And then recompute phic,
!     and then recompute dphic.
!
      sumc  = 0
      scphi = 0
      DO 40 I=1,N
      IF(C(I).GT.0.0 ) THEN
      scphi = scphi + dphi(i)*C(I)
      SUMC = SUMC + C(I)
      END IF
40    CONTINUE

      cphic = scphi/sumc
      phic  = phic + cphic

      do 50 i=1,n
      dphi(i) = dphi(i) - cphic
50    continue

!     STEP FIVE: SORT DPHI VALUES, LOWEST TO HIGHEST
!
      CALL SORT3(DPHI,AX,AY,AC,N,IERR)
!
      IF(IERR.LT.0) GO TO 70
!
!   STEP SIX:  COMPUTE PHI VALUES
!
      DO 60 I=1,N
      X(I) = AX(I)
      Y(I) = AY(I)
      C(I) = AC(I)
      PHI(I) = DPHI(I) + PHIC
60    CONTINUE

70    RETURN
      END

 
      SUBROUTINE SORT3(Y,W,X,Z,N,IERR)

      PARAMETER (NMAX=50000)
!
!  SHELL SORT OF N VALUES IN Y-ARRAY FROM
!   LARGEST TO SMALLEST.
!
      INTEGER I,J,J1,GAP,NMG,IERR
      REAL TY,TW,TX,TZ
      REAL Y(NMAX),W(NMAX),X(NMAX),Z(NMAX)
      
      IERR = 0
!
      IF(N.GT.NMAX) THEN
      IERR = -4
      GO TO 999
      END IF
!
      IF(N.GE.1) GO TO 10
      IERR = -5
      GO TO 999
!
   10 IF(N.EQ.1) GO TO 999
!
!  ONE ELEMENT ARRAYS ARE SORTED
!  BY DEFINITION.
!
      GAP = N
   20 GAP = GAP/2
      NMG = N - GAP
      DO 40 J1 = 1,NMG
      I = J1 + GAP
!
!   LOOP J = J1,1,-GAP
!
      J = J1
   30 IF(Y(J).LE.Y(I)) GO TO 40
!
!  SWAP OUT-OF-ORDER PAIRS
!
!       SET IERR TO +2 TO INDICATE
!       REORDERING WAS NEEDED TO
!       SORT ARRAY
!
      IERR = +2
!
      TY = Y(I)
      TW = W(I)
      TX = X(I)
      TZ = Z(I)
!
      Y(I) = Y(J)
      W(I) = W(J)
      X(I) = X(J)
      Z(I) = Z(J)
!
      Y(J) = TY
      W(J) = TW
      X(J) = TX
      Z(J) = TZ
!
!   KEEP OLD POINTER FOR NEXT TIME THROUGH
!
      I = J
      J = J - GAP
      IF(J.GE.1) GO TO 30
   40 CONTINUE
      IF(GAP.GT.1) GO TO 20
  999 RETURN
      END

      SUBROUTINE SORT2(Y,X,N,IERR)

      PARAMETER (NMAX=50000)
!
!   SHELL SORT OF N VALUES IN Y-ARRAY FROM
!   LARGEST TO SMALLEST.
!
      INTEGER I,J,J1,GAP,NMG,IERR
      REAL TY,TX
      REAL Y(NMAX),X(NMAX)
      
      IERR = 0
!
      IF(N.GT.NMAX) THEN
      IERR = -4
      GO TO 999
      END IF
! 
      IF(N.GE.1) GO TO 10
      IERR = -5
      GO TO 999
!
   10 IF(N.EQ.1) GO TO 999
!
!  ONE ELEMENT ARRAYS ARE SORTED
!  BY DEFINITION.
!
      GAP = N
   20 GAP = GAP/2
      NMG = N - GAP
      DO 40 J1 = 1,NMG
      I = J1 + GAP
!
!   LOOP J = J1,1,-GAP
!
      J = J1
   30 IF(Y(J).LE.Y(I)) GO TO 40
!
!  SWAP OUT-OF-ORDER PAIRS
!
!       SET IERR TO +2 TO INDICATE
!       REORDERING WAS NEEDED TO
!       SORT ARRAY
!
      IERR = +2
!
      TY = Y(I)
      TX = X(I)
!
      Y(I) = Y(J)
      X(I) = X(J)
!
      Y(J) = TY
      X(J) = TX
!
!   KEEP OLD POINTER FOR NEXT TIME THROUGH
!
      I = J
      J = J - GAP
      IF(J.GE.1) GO TO 30
   40 CONTINUE
      IF(GAP.GT.1) GO TO 20
  999 RETURN
      END

      SUBROUTINE SYSM(NUM,WC,WR,SYEST,IERR)
!
!     COMPUTE LATERAL DISPERSION FROM SECOND MOMENT
!     OF CONCENTRATION VALUES ABOUT CENTROID POSITION
!
!     WE ASSUME WR IS IN METERS AND
!     WC ARE VALID CONCENTRATION VALUES
!
      PARAMETER (NMAX=200)
      DIMENSION WC(NMAX),WR(NMAX)

      IF( NUM.GE.3 ) THEN
      IERR = 0
      SUMCR2 = 0.0
      SUMC   = 0.0
      DO 10 I = 1,NUM
      SUMCR2 = SUMCR2 + WC(I)*WR(I)*WR(I)
      SUMC   = SUMC + WC(I)
10    CONTINUE
      SYEST = SQRT( SUMCR2/SUMC )
      ELSE
      SYEST = -999.
      IERR = -2
      END IF

      RETURN
      END

      SUBROUTINE SORT1(Y,N,IERR)

      PARAMETER (NMAX=50000)
!
!   SHELL SORT OF N VALUES IN Y-ARRAY FROM
!   LARGEST TO SMALLEST.
!
      INTEGER I,J,J1,GAP,NMG,IERR
      REAL TY
      REAL Y(NMAX)
      
      IERR = 0
!
      IF(N.GT.NMAX) THEN
      IERR = -4
      GO TO 999
      END IF
!
      IF(N.GE.1) GO TO 10
      IERR = -5
      GO TO 999
!
   10 IF(N.EQ.1) GO TO 999
!
!  ONE ELEMENT ARRAYS ARE SORTED
!  BY DEFINITION.
!
      GAP = N
   20 GAP = GAP/2
      NMG = N - GAP
      DO 40 J1 = 1,NMG
      I = J1 + GAP
!
!   LOOP J = J1,1,-GAP
!
      J = J1
   30 IF(Y(J).LE.Y(I)) GO TO 40
!
!  SWAP OUT-OF-ORDER PAIRS
!
!       SET IERR TO +2 TO INDICATE
!       REORDERING WAS NEEDED TO
!       SORT ARRAY
!
      IERR = +2
!
      TY = Y(I)
!
      Y(I) = Y(J)
!
      Y(J) = TY
!
!   KEEP OLD POINTER FOR NEXT TIME THROUGH
!
      I = J
      J = J - GAP
      IF(J.GE.1) GO TO 30
   40 CONTINUE
      IF(GAP.GT.1) GO TO 20
  999 RETURN
      END

      SUBROUTINE AREATP(NUM,C,Y,CYTRAP,key)

      PARAMETER (NMAX=200)
!
!     AREA CALCULATES THE INTEGRAL OF C OVER WY BY
!     TRAPIZOIDAL INTEGRATION. IT IS NOT NECESSARY
!     THAT VALUES OF Y BE EVENLY SPACED.
!
!     NUM=NUMBER OF DATA POINTS TO BE INTEGRATED
!     C concentration divided by q
!     WY = distance from center of mass along arc
!          having radius equal to average distance of
!          receptors from the source (m)
!     CYTRAP=INTEGRAL OF C OVER WY

      DIMENSION C(NMAX),Y(NMAX),wr(nmax),wc(nmax)

!     test number of values
      if( num.gt.nmax ) then
	  write(*,*) 'Subroutine areatp '
	  write(*,*) 'Num = ',num,' nmax = ',nmax
	  stop
	  end if

      itest  = 1
      icount = 0
!     COPY DATA INTO WORK ARRAYS

      if( itest.eq.1 ) then
      DO I=1,NUM
	    if( c(i) .ge. 0 ) then
	    icount = icount + 1
	    WR(I) = Y(I)
        WC(I) = C(I)
        end if
      end do
      end if
      
      if ( itest.ne.1 ) then
      DO I=1,NUM
	   if( c(i) .ge. 0 ) then
       WR(I) = Y(I)
       WC(I) = C(I)
       else
	   WR(I) = Y(I)
       WC(i) = cfill(num,i,c)
       end if
      end do
      end if
   
	  if( itest.eq. 1) then
	  nwork = icount
	  else
	  nwork = num
	  end if
	  
10    CONTINUE

!     SORT DATA IN TERMS OF R, CARRY C-VALUES ALONG
!     NOTE:  SORTED IN TERMS OF R, FROM SMALLEST TO LARGEST
      CALL SORT2(WR,WC,Nwork,IERR)


!     NOW READY TO INTEGRATE OVER WR

      IF( Nwork.LE.2 ) THEN
      CYTRAP = -999.
      GO TO 100
      END IF

      cytrap = 0
      DO 50 I = 2,Nwork
!     NOTE: WR IS SORTED SMALLEST TO LARGEST
      c2 = wc(i)
	  c1 = wc(i-1)
  	  r2 = wr(i)
	  r1 = wr(i-1)
	  cavg = 0.5*(c1+c2)
	  delr = abs(r1-r2 )
	  ctest = cavg*delr
      cytrap = cytrap + ctest
50    CONTINUE
!
!     assume first and last increment are bounded by
!     zero.
!     if (key) is not zero, then
!     add small 'tails' to match this assumption
!
      if(key.ne.0) then
	  delr = abs(wr(2)-wr(1))
	  f1 = 0.5*wc(1)*delr

	  delr = abs(wr(nwork)-wr(nwork-1))
	  f2 = 0.5*wc(nwork)*delr

	  else
	  f1 = 0.0
	  f2 = 0.0
	  end if

      cytrap = cytrap + f1 + f2

100   continue
      RETURN
      END

      function cfill(num,index,c)
!
!     try to interpolate for a missing value
!     within the concentration pattern
!
      parameter (nmax=200)
      dimension c(nmax),y(nmax)
!
      if(num.gt.nmax) then
      write(*,*)'In function cfill, and num>nmax'
      stop
      end if

!     find valid conc. below index position
      if( index.eq.1 ) then
      clow = 0.0
      go to 20
      end if

      ilook = index -1
      if( c(ilook).ge.0.0 ) then
      clow = c(ilook)
      else
      clow = 0.0
      end if

20    continue
!     find valid conc. above index position
      if( index.eq.num ) then
      chigh = 0.0
      go to 30
      end if

      ilook = index + 1
      if( c(ilook).ge.0.0 ) then
      chigh = c(ilook)
      else
      chigh = 0.0
      end if

30    continue
      cfill = 0.5*(clow+chigh)
      return
      end
